unit BarreCar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TBarreCaract = class(TForm)
    ComboTypes: TComboBox;
    ComboCar: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure AfficheCar(Num:Integer);
    procedure ComboTypesChange(Sender: TObject);
    procedure ComboCarChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    NumType: integer;
  public
    { Dclarations publiques }
    procedure AjusteListes;
  end;

var
  BarreCaract: TBarreCaract;

implementation

uses StructureDonnees,Donnees, PhylObs, PhylComp,PhylMain;

{$R *.DFM}


procedure TBarreCaract.AjusteListes;
var
  i:integer;
  Tax:TTaxon;
begin
  ComboTypes.Items.Clear;
  for i:=0 to LaSousCollection.Caracteres.TypeCaract.Count-1 do
   ComboTypes.Items.Add(LaSousCollection.Caracteres.TypeCaract[i]);
   if FormObs.Visible and (FormObs.Selection.Count>0) then
     begin
       Tax:=FormObs.TaxonSelect;
       if (Tax<>nil) and (Tax.DocsDivers.Count>0) then
       ComboTypes.Items.Add('Diverses');
     end;
end;

procedure TBarreCaract.FormCreate(Sender: TObject);
var i:integer;
begin
  for i:=0 to LaSousCollection.Caracteres.TypeCaract.Count-1 do
   ComboTypes.Items.Add(LaSousCollection.Caracteres.TypeCaract[i]);
end;

procedure TBarreCaract.FormShow(Sender: TObject);
var
  i: integer; //,nt
  Tax:TTaxon;
  //NomTaxon:string;
begin
  ComboCar.Visible:=False;
  // Combo des types de caractres
  with ComboTypes do
  begin
    Clear;
    if (Self.Parent.Name='FormComp') then
      begin
        for i:=0 to LaSousCollection.Caracteres.NumTypeComp.Count-1 do
          Items.Add(LaSousCollection.Caracteres.TypeCaract[LaSousCollection.Caracteres.GetNumTypeComp(i)]);
        if Items.IndexOf('Morphologiques')=-1 then
          Items.Add('Morphologiques');
      end
    else
      begin
        for i:=0 to LaSousCollection.Caracteres.TypeCaract.Count-1 do
          Items.Add(LaSousCollection.Caracteres.TypeCaract[i]);
        if FormObs.Selection.Count>0 then
          begin
            Tax:=FormObs.TaxonSelect;
            if (Tax<>nil) and (Tax.DocsDivers.Count>0) then
              Items.Add('Diverses');
          end;
      end;
     Text:='Donnes';
     Hint:='Choisir un type de donnes';
     SelStart:=0;
  end;   
end;

procedure TBarreCaract.AfficheCar(Num: Integer);
begin
   if (Parent.Name='FormObs') then
     begin
       if ComboTypes.Text='Diverses' then
         FormObs.ChargeDoc(ComboCar.Text)
       else FormObs.AfficheCaract(FormObs.ImageEsp.Tag,Num);
     end
   else if (Parent.Name='FormComp') then
      FormComp.AfficheCaract(Num);
end;


procedure TBarreCaract.ComboTypesChange(Sender: TObject);
// change la combo des caracteres en fn du type
var
   N,i: integer;
begin
 RAZControleACopier;   // Ajout JFM
 with TComboBox(Sender) do
   begin
     if (ItemIndex > Items.Count-1) or (ItemIndex < 0) then exit;
     SelStart:=0;
     if Items[ItemIndex]='Morphologiques' then   // donnes morpho pour la comparaison
       begin
         ComboCar.Visible:=false;
         FormComp.AfficheEspeces;
         exit;
       end;
     if Self.Parent.Name='FormComp' then
       NumType:=LaSousCollection.Caracteres.GetNumTypeComp(ItemIndex)
     else
       NumType:=ItemIndex;
   end;
  ComboCar.Clear;
  if FormObs.Visible and (ComboTypes.Text='Diverses') then
    begin
      N:=FormObs.TaxonSelect.DocsDivers.Count;
      if N=0 then
        begin
          ComboTypes.Items.Delete(ComboTypes.ItemIndex);
          ComboTypes.ItemIndex:=0;
        end
      else if N=1 then
        begin
          ComboCar.Visible:=False;
          FormObs.ChargeDoc(FormObs.TaxonSelect.DocsDivers[0]);
        end
      else
        begin
          ComboCar.Visible:=True;
          ComboCar.Text:='Donnes disponibles';
          ComboCar.Hint:='Donnes disponibles';
          ComboCar.SelStart:=0;
          ComboCar.Items.AddStrings(FormObs.TaxonSelect.DocsDivers);
        end;
    end
  else
    begin
      N:= LaSousCollection.Caracteres.GetNbCar(NumType);
      if N=1 then               // si un seul caractre
        begin
          ComboCar.Visible:=False; // on n'affiche pas la combo des caractres
          AfficheCar(LaSousCollection.Caracteres.GetNumCar(NumType,0)); // on affiche directement l'image du caractre
        end
      else                      // sinon on affiche la combo des caractres
        begin
          ComboCar.visible:=True;
          ComboCar.Text:='Donnes disponibles';
          ComboCar.Hint:='Donnes disponibles';
          ComboCar.SelStart:=0;
          for i:=0 to N - 1 do
            ComboCar.Items.Add(LaSousCollection.Caracteres.GetNom(LaSousCollection.Caracteres.GetNumCar(NumType,i)));
        end;
    end;
end;

procedure TBarreCaract.ComboCarChange(Sender: TObject);
begin
   RAZControleACopier;
   with TComboBox(Sender) do
     begin
       if (ItemIndex > -1) and (ItemIndex < Items.Count) then
         begin
           if ComboTypes.Text='Diverses' then FormObs.ChargeDoc(Text)
           else AfficheCar(LaSousCollection.Caracteres.GetNumCar(NumType,TComboBox(Sender).ItemIndex));
         end;
     end;
end;

{procedure TBarreCaract.AjouteMorpho;
var
   ind:integer;
begin
   ind:= ComboTypes.Items.IndexOf('Morphologiques');
   if (Parent.Name='FormComp') and (ind=-1) then
        ComboTypes.Items.Add('Morphologiques');
   if (Parent.Name='FormObs') and (ind <> -1) then
        ComboTypes.Items.Delete(ind);
end;  }

end.
