unit CompCadreIma2;
// Un TCompCadreIma2 est un TPanel contenant un TImage et un TLabel
// Pour afficher une image avec lgende : Affiche(NomFichier,Legende)
// Si NomFichier='' on affiche la lgende avec une Image blanche
// Si Legende='' on affiche seulement l'image
// La fonte de la lgende est la mme que celle du TPanel
//(on peut donc la modifier facilement)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Donnees,ExtCtrls;

type
  //TCliqueImage=procedure(Sender:TTCadreImage2;Picture:TPicture);
  TCadreImage2=class(TPanel)
  private
     Image:TImage;
     FClientR:TRect;
     FLegende:TLabel;
     FSelected:boolean;
     procedure AjusteZoneClient;
     procedure Clique(Sender:TObject);
     procedure DoubleClique(Sender:TObject);
     procedure SourisMove(Sender: TObject;Shift: TShiftState; X, Y: Integer);
     procedure SourisDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
     procedure AfficheLegende(L: string);
     procedure SetSelected(Value: boolean);
     procedure AfficheEtat; // change apparence du bouton en fn de l'tat (selectionne ou non)
  public
     TypeTax:string;
     constructor Create(AOwner: TComponent);override;
     destructor Destroy;override;
     procedure Affiche(NomFichier:string;Legende:string);
     property Selected:boolean read FSelected write SetSelected;
     property GetImage:TImage read Image;
  end;

procedure Register;


implementation

constructor TCadreImage2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:=TWinControl(AOwner);
  Color:=clWhite; // pourrait tre fixe  l'extrieur
  Caption:='';

  Image:=TImage.Create(Self);
  Image.Parent:=Self;
  Image.OnClick:=Clique;
  Image.OnDblClick:=DoubleClique;
  Image.OnMouseMove:=SourisMove;
  Image.OnMouseDown:=SourisDown;

  FLegende:=TLabel.Create(Self);
  FLegende.Parent:=Self;
  FLegende.Autosize:=false;
  FLegende.Visible:=false;
  FLegende.OnClick:=Clique;
  FLegende.OnDblClick:=DoubleClique;
  FLegende.OnMouseMove:=SourisMove;
  FLegende.OnMouseDown:=SourisDown;

  Selected:=false;
end;
procedure TCadreImage2.SourisMove(Sender: TObject;Shift: TShiftState; X, Y: Integer);
begin
   if Assigned(OnMouseMove) then Self.OnMouseMove(Self,Shift,X,Y);
end;
procedure TCadreImage2.SourisDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
Var
  Y0:integer;
begin
  Y0:=0;
  If (Sender=FLegende) then Y0:=Image.Height;
  if Assigned(OnMouseDown) then Self.OnMouseDown(Self,Button,Shift,X,Y+Y0);
end;
procedure TCadreImage2.Clique(Sender:TObject);
begin
   if Assigned(OnClick) then Self.Onclick(Self);
end;
procedure TCadreImage2.DoubleClique(Sender:TObject);
begin
   if Assigned(OnDblClick) then Self.OnDblclick(Self);
end;
procedure TCadreImage2.AjusteZoneClient;
begin
  FClientR:=ClientRect;
  AdjustClientRect(FClientR);
end;

procedure TCadreImage2.Affiche(NomFichier:string;Legende:string);
var
  sr: TSearchRec;
  FileAttrs : Integer;
  nomIcone:string;
begin
  AjusteZoneClient;
  Image.Left:=FClientR.Left;
  Image.Top:=FClientR.Top;
  Image.Width:=FClientR.Right-FClientR.Left;
  Image.Height:=FClientR.Bottom-FClientR.Top-FLegende.Canvas.TextHeight(Legende);
  Image.Center:=True;
  if (NomFichier = '') then Image.Picture:=nil
  else Image.Picture.LoadFromFile(NomFichier) ;
{  else begin
        FileAttrs :=  faAnyFile;
       if FindFirst(NomFichier, FileAttrs, sr) <> 0 then
         begin
           if FindFirst(CheminColl+'\imageColl.bmp', FileAttrs, sr) <> 0 then   Image.Picture:=nil
           else Image.Picture.LoadFromFile(CheminColl+ '\imageColl.bmp') ;
         end else Image.Picture.LoadFromFile(NomFichier) ;
       FindClose(sr);
       end;}
  AfficheLegende(Legende);
end;

procedure TCadreImage2.AfficheLegende(L: string);
begin
  AjusteZoneClient;
  FLegende.Caption:=L;
  FLegende.Alignment:=taCenter;
  if L='' then FLegende.Height:=0;
  FLegende.Left:=FClientR.Left;
  FLegende.Top:=FClientR.Bottom-FLegende.Height;
  FLegende.Width:=FClientR.Right-FClientR.Left;
  FLegende.Font.Assign(Font);
  FLegende.Refresh;
  FLegende.Visible:=True;
end;

procedure Register;
begin
   RegisterComponents('Phylo',[TCadreImage2]);
end;

destructor TCadreImage2.Destroy;
begin
   Image.Free;
   FLegende.Free;
   inherited Destroy;
end;

procedure TCadreImage2.SetSelected(Value: boolean);
begin
   FSelected:=Value;
   AfficheEtat;
end;

procedure TCadreImage2.AfficheEtat;
begin
   if FSelected then
     begin
       if pos('F',TypeTax)>0 then
         begin
           FLegende.Color:=clYellow;//clAqua;//clBlue;
           Flegende.Font.Color:=clRed; //$8282FF;
         end
       else if pos('E',TypeTax)>0 then
         begin
           FLegende.Color:=clYellow;
           Flegende.Font.Color:= clBlue;
         end
       else
         begin
           FLegende.Color:=clYellow;//clBlue;
           Flegende.Font.Color:= clBlack;//clWhite;
         end;
       FLegende.Align := alBottom;
     end
   else
     begin
       if pos('F',TypeTax)>0 then
         begin
           FLegende.Color:=clWhite;
           Flegende.Font.Color:= clRed;// $8282FF;
         end
       else if pos('E',TypeTax)>0 then
         begin
           FLegende.Color:=clWhite;
           Flegende.Font.Color:= clBlue;
         end
       else
         begin
           FLegende.Color:=clWhite;
           Flegende.Font.Color:=clBlack;
         end;
     end;
end;

end.
