unit PhylObs;

// DL 17/07/01 modif FormClose pour corriger bug sur ouverture successive de 2
//             fichiers d'images diffrents

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, BarreIc, jpeg, ComCtrls, CompCadreIma2,StructureDonnees,Donnees;

type
  TFormObs = class(TForm)
    NomEsp: TLabel;
    NomCar: TLabel;
    TexteCar: TRichEdit;
    ImageEsp: TCadreImage2;
    ImageCar: TCadreImage2;
    RectFoc: TShape;
    MemoCopie: TMemo;
    procedure AfficheEspece(NumEsp:integer);
    procedure AfficheCaract(NumEsp,NumCar:integer);
    procedure FormCreate(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure TexteCarMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ACopier(Sender: TObject);
  private
    { Dclarations prives }
    FSelection:TStringList;     // Pour compatibilit avec PhylComp et PhylChoi
    function GetSelection: TStringList;
    function GetTaxon:TTaxon;
  public
    { Dclarations publiques }
    property Selection:TStringList read GetSelection;
    property TaxonSelect:TTaxon read GetTaxon;
    procedure ChargeDoc(NomDoc:string);
  end;

var
  FormObs: TFormObs;

implementation

uses PhylMain, BarreCar,PhylBig, PhylGlo, PhylDef,utils;
{$R *.DFM}

function TFormObs.GetTaxon:TTaxon;
Var
  NumTaxon:integer;
begin
  Result:=nil;
  if selection.Count>0 then
    begin
      NumTaxon:=LaSousCollection.Taxons.GetNumTaxon(Selection[0]);
      if NumTaxon>-1 then
        Result:=TTaxon(LaSousCollection.Taxons.Items[NumTaxon]);
    end;
end;
procedure TFormObs.ChargeDoc(NomDoc:string);
Var
  Ext:string;
  JPEGImage:TJPEGImage;
  //larg,haut:integer;
begin
  Ext:=UpperCase(ExtractFileExt(NomDoc));
  NomDoc:=CheminCaract+TaxonSelect.Image+'\'+NomDoc;
  MemoCopie.Visible:=False;
  TexteCar.Visible:=false;
  ImageCar.Visible:=false;
  If Not FileExists(NomDoc) then exit;
  if (Ext='.TXT') then
    begin
      TexteCar.Lines.LoadFromFile(NomDoc);
      TexteCar.Visible:=True;
      //MemoCopie.Lines.LoadFromFile(NomDoc);
      //MemoCopie.Visible:=True;
    end
  else if (Ext='.RTF') then
    begin
      TexteCar.Lines.LoadFromFile(NomDoc);
      TexteCar.Visible:=True;
      //MemoCopie.Lines.Clear;
      //MemoCopie.Lines.AddStrings(TexteCar.Lines);
      //MemoCopie.Visible:=true;
    end
  else if (Ext='.JPG') then
    begin
      ImageCar.Top:=ImageEsp.Top;
      ImageCar.Height:=2*HauteurPetiteImage;
      JPEGImage:=TJPEGImage.Create;
      JPEGImage.LoadFromFile(NomDoc);
      if (JPEGImage.Width<=ImDocW) and (JPEGImage.Height<=ImDocBH) then
        begin
          ImageCar.Affiche(NomDoc,'');
          ImageCar.Visible:=True;
       end
      else chargeFichierWin(Handle,NomDoc);
      JPEGImage.Free;
    end
  else if Ext<>'' then chargeFichierWin(Handle,NomDoc);
end;

procedure TFormObs.FormCreate(Sender: TObject);
begin
   FormPrinc.Fille(Self);
   Self.Visible:=false;
   with ImageEsp do
   begin
      Width:=LargeurPetiteImage;
      Height:=HauteurPetiteImage;
      Tag:=-1;
   end;
   with ImageCar do
   begin
      Visible:=false;
      //Left:=ImageEsp.Left+ImageEsp.Width+50;
      Width:=ImageEsp.Width;
      Left:=Self.Width-Width-5;
      Tag:=-1; // numero du car courant, 0 correspond au 1er caractre
   end;
   with TexteCar do
   begin
      Visible:=false;
      Top:=ImageEsp.Top;
      Left:=ImageCar.Left;
      Width:=ImageCar.Width;
   end;
   with MemoCopie do
   begin
      Visible:=false;
      Top:=ImageEsp.Top;
      Left:=ImageCar.Left;
      Width:=ImageCar.Width;
   end;

   FSelection:=TStringList.Create; 
end;

procedure TFormObs.FormPaint(Sender: TObject);
begin
//Barre d'icones en bas  gauche
  with BarreIcones do
  begin
     Parent:=Self;
//     if Screen.Height=480 then Top:=400 else Top:=410;
     Left:=0;
     Top:=Self.ClientHeight-Height-10;
     Show;
  end;   
// Barre des caractres  ct, en haut JFM 05/08
  with BarreCaract do
  begin
     Parent:=Self;
     if Parent.Height<610 then Top:=BarreIcones.Top+40
     else Top:=BarreIcones.Top;//  + BarreIcones.Height - Height;
     Left:= BarreIcones.Left + BarreIcones.Width + 10;
     Show;
  end;
end;

procedure TFormObs.AfficheEspece(NumEsp:integer);
var
  NumCar: integer;
  NomImageTaxon: string;
  NomTaxon:string;
begin
  NomImageTaxon:= LaSousCollection.Taxons.GetImage(NumEsp);
  if FileExists(NomImageTaxon) then
    begin
      NomTaxon:=LaSousCollection.Taxons.GetNom(NumEsp);
      if LaSousCollection.EstFossile(NumEsp) then
        begin
          NomTaxon:=NomTaxon+' F '+LaSousCollection.AgesStr(NumEsp);
          NomEsp.Font.color:=$A0A0FF;//$9292FF;//$3131FF;//clRed;
        end
      else if LaSousCollection.EstExterne(NumEsp) then NomEsp.Font.color:=clSkyBlue
      else NomEsp.Font.color:=clWhite;
      ImageEsp.Affiche(NomImageTaxon,'');
      ImageEsp.Visible:=true;
    end
  else
    begin
      ImageEsp.Visible:=false;
      ShowMessage('Le fichier '+ NomImageTaxon +' n''existe pas');
    end;
  NomEsp.Caption:=NomTaxon;
  ImageEsp.Tag:=NumEsp;
  NumCar:=ImageCar.Tag;

  BarreCaract.AjusteListes;
  if NumCar<>-1 then
    AfficheCaract(NumEsp,NumCar)
  else
    BarreCaract.ComboCarChange(BarreCaract.ComboCar);
end;

procedure TFormObs.AfficheCaract(NumEsp,NumCar:integer);
// affiche un texte et ventuellement une petite image
// ou une grande image s'il n'y a pas de texte
var
  NomTexteCar:string;
  NomImageCar:string;
  NomImageCarBig:string;
begin
  if ImageEsp.Tag=-1 then exit;
  NomTexteCar:= LaSousCollection.Taxons.GetTexteCar(NumEsp,NumCar);
  NomImageCar:= LaSousCollection.Taxons.GetImageCar(NumEsp,NumCar);
  if FileExists(NomTexteCar) then
    begin
      // Affichage du texte
      TexteCar.Lines.Clear;
      TexteCar.Lines.LoadFromFile(NomTexteCar);
      TexteCar.Visible:=true;
      MemoCopie.Visible:=false;

      TexteCar.Refresh;
      //MemoCopie.Lines.Clear;
      //MemoCopie.Lines.AddStrings(TexteCar.Lines);
      //MemoCopie.Visible:=true;
      if FileExists(NomImageCar) then
        begin
          // Affichage d'une petite image  en-dessous
          ImageCar.Top:=TexteCar.Top+TexteCar.Height;
          ImageCar.Height:=HauteurPetiteImage;
          ImageCar.Affiche(NomImageCar,'');
          ImageCar.Visible:=True;
        end
      else
        begin
          ImageCar.Visible:=false;
        end;
    end
  else
    begin
      TexteCar.Visible:=false;
      MemoCopie.Visible:=false;
      NomImageCarBig:= LaSousCollection.Taxons.GetImageCarBig(NumEsp,NumCar);
      if FileExists(NomImageCarBig) then
        begin // Affichage d'une grande image
          ImageCar.Top:=ImageEsp.Top;
          ImageCar.Height:=2*HauteurPetiteImage;
          ImageCar.Affiche(NomImageCarBig,'');
          ImageCar.Visible:=True;
        end
      else if FileExists(NomImageCar) then
        begin
          // Affichage d'une petite image dans le grand cadre
          ImageCar.Top:=ImageEsp.Top;
          ImageCar.Height:=2*HauteurPetiteImage;
          ImageCar.Affiche(NomImageCar,'');
          ImageCar.Visible:=True;
        end
      else
        begin                // texte indiquant l'absence de donnee
          ImageCar.Visible:=false;
          TexteCar.Text:=MsgDonneeAbsente;
          TexteCar.Visible:=false;
          MemoCopie.Lines.Clear;
          MemoCopie.Lines.Add(MsgDonneeAbsente);
          MemoCopie.Visible:=true;
        end;
   end;
  ImageCar.Tag:=NumCar;
end;

procedure TFormObs.ImageClick(Sender: TObject);   // supprimer et remplacer par une autre fentre
begin
  Application.CreateForm(TFormBig, FormBig);
  FormBig.Parent:=Self;
  FormBig.AgrandirImage(Sender);
end;

procedure TFormObs.TexteCarMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Terme:string;
begin
  Terme:= TRichEdit(Sender).SelText;
  if Terme <> '' then FormDefinition.AfficheDefinition(Terme);
end;

function TFormObs.GetSelection: TStringList;
begin
  FSelection.Clear;
  if (Assigned(LaSousCollection.Taxons)) and (ImageEsp.Tag <> -1) then FSelection.Add(LaSousCollection.Taxons.GetNom(ImageEsp.Tag));
  GetSelection:=FSelection;
end;

procedure TFormObs.FormShow(Sender: TObject);
begin
  //FormPrinc.Observer1.Enabled:=false;  // jfr modifie 16 octobre 2001
  BarreIcones.Show;
end;

procedure TFormObs.FormHide(Sender: TObject);
begin
   //FormPrinc.Observer1.Enabled:=true;   // jfr modifie 16 octobre 2001
   BarreIcones.Hide;
end;

procedure TFormObs.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   ImageEsp.Tag:=-1;
   ImageCar.Tag:=-1;
   ImageCar.Visible:=false;
   ImageEsp.Visible:=false;
   FSelection.Clear;
   RectFoc.Visible:=False;
end;

procedure TFormObs.ACopier(Sender: TObject);
begin
  ControleACopier:=(Sender as TwinControl);
  RectFoc.Visible:=True;
  RectFoc.Left:=ControleACopier.Left-3;
  RectFoc.Top:=ControleACopier.Top-3;
  RectFoc.Width:=ControleACopier.Width+6;
  RectFoc.Height:=ControleACopier.Height+6;
end;

end.
